"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.joinClass = exports.callFunctions = void 0;

var callFunctions = function callFunctions() {
  for (var _len = arguments.length, functions = new Array(_len), _key = 0; _key < _len; _key++) {
    functions[_key] = arguments[_key];
  }

  return function () {
    for (var i = 0; i < functions.length; i++) {
      if (undefined !== functions[i]) {
        functions[i].apply(functions, arguments);
      }
    }
  };
};

exports.callFunctions = callFunctions;

var joinClass = function joinClass() {
  for (var _len2 = arguments.length, classes = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    classes[_key2] = arguments[_key2];
  }

  return classes.filter(function (value) {
    return undefined !== value && 0 !== value.length;
  }).join(' ');
};

exports.joinClass = joinClass;