"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Input = _interopRequireDefault(require("./components/Input.js"));

var _IsAlphanumeric = _interopRequireDefault(require("./components/IsAlphanumeric.js"));

var _IsEmail = _interopRequireDefault(require("./components/IsEmail.js"));

var _IsLengthValid = _interopRequireDefault(require("./components/IsLengthValid.js"));

var _IsNumber = _interopRequireDefault(require("./components/IsNumber.js"));

var _IsRegexValid = _interopRequireDefault(require("./components/IsRegexValid.js"));

var _IsRequired = _interopRequireDefault(require("./components/IsRequired.js"));

var _IsValueValid = _interopRequireDefault(require("./components/IsValueValid.js"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Submit = _interopRequireDefault(require("./components/Submit.js"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Index(_ref) {
  var As = _ref.as,
      Children = _ref.children,
      Id = _ref.id,
      IncludeForm = _ref.includeForm,
      otherProps = _objectWithoutProperties(_ref, ["as", "children", "id", "includeForm"]);

  var _useState = (0, _react.useState)({
    validators: {}
  }),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  if (undefined === state.validators[Id]) {
    state.validators[Id] = {
      inputs: [],
      results: []
    };
  } else {
    state.validators[Id].results = [];
  }

  var onInputChange = function onInputChange(event) {
    state.validators[Id].inputs[event.target.id].changed = true;
    state.validators[Id].inputs[event.target.id].value = event.target.value;
    setState(Object.assign({}, state));
  };

  var onSubmitClick = function onSubmitClick(event) {
    event.preventDefault();

    for (var inputKey in state.validators[Id].inputs) {
      state.validators[Id].inputs[inputKey].changed = true;
    }

    setState(Object.assign({}, state));
  };

  var elHelper = 0;

  var prepare = function prepare(el, index) {
    if (-1 !== ['function', 'object'].indexOf(_typeof(el.type)) && -1 !== Object.keys(Index).indexOf(el.type.name)) {
      if ("Input" === el.type.name && undefined === state.validators[Id].inputs[el.props.id]) {
        state.validators[Id].inputs[el.props.id] = {
          changed: false,
          rules: [],
          value: ''
        };
      }

      if (undefined !== el.props.rule) {
        if (undefined !== el.props["for"]) {
          var result = el.props.rule(state.validators[Id].inputs[el.props["for"]].value, el.props);
          state.validators[Id].inputs[el.props["for"]].rules[el.type.name] = result;
          state.validators[Id].results.push(result);
        } else {
          state.validators[Id].results.push(el.props.rule(el.props.value, el.props));
        }
      }
    } else if (undefined !== el.props && undefined !== el.props.children) {
      for (var i = 0; i < el.props.children.length; i++) {
        prepare(el.props.children[i], index);
      }
    }
  };

  var render = function render(el, index) {
    if (-1 !== Object.keys(Index).indexOf(el.type.name)) {
      if ("Input" === el.type.name) {
        return _react["default"].createElement(el.type, _extends({
          key: index,
          rfivOnChange: onInputChange,
          rfivShowErr: -1 !== Object.values(state.validators[Id].inputs[el.props.id].rules).indexOf(false) && state.validators[Id].inputs[el.props.id].changed
        }, el.props), el.props.children);
      } else if ("Submit" === el.type.name) {
        return _react["default"].createElement(el.type, _extends({
          key: index,
          rfivFormResult: -1 === state.validators[Id].results.indexOf(false),
          rfivOnClick: onSubmitClick
        }, el.props), el.props.children);
      }

      return _react["default"].createElement(el.type, _extends({
        key: index,
        rfivShowErr: !state.validators[Id].results[elHelper++] && (undefined === el.props["for"] || state.validators[Id].inputs[el.props["for"]].changed)
      }, el.props), el.props.children);
    } else if (undefined !== el.props && undefined !== el.props.children) {
      if ('string' === typeof el.props.children) {
        return el.props.children;
      } else if (undefined !== el.props.children.length) {
        var output = [];

        for (var i = 0; i < el.props.children.length; i++) {
          output.push(render(el.props.children[i], index + '-' + i));
        }

        return _react["default"].createElement(el.type, _extends({
          key: index
        }, el.props), output);
      } else {
        return _react["default"].createElement(el.type, _extends({
          key: index
        }, el.props), render(el.props.children, index + '-' + 0));
      }
    }

    return _react["default"].createElement(_react["default"].Fragment, {
      key: index
    }, el);
  };

  _react["default"].Children.map(Children, prepare);

  var children = _react["default"].Children.map(Children, render);

  if (undefined !== As) {
    return _react["default"].createElement(As, _extends({
      id: Id
    }, otherProps), children);
  }

  return IncludeForm ? _react["default"].createElement("form", _extends({
    id: Id
  }, otherProps), children) : children;
}

Index.propTypes = {
  as: _propTypes["default"].elementType,
  id: _propTypes["default"].string.isRequired,
  includeForm: _propTypes["default"].bool
};
Index.defaultProps = {
  includeForm: true
};
Index.Input = _Input["default"];
Index.IsAlphanumeric = _IsAlphanumeric["default"];
Index.IsEmail = _IsEmail["default"];
Index.IsLengthValid = _IsLengthValid["default"];
Index.IsNumber = _IsNumber["default"];
Index.IsRegexValid = _IsRegexValid["default"];
Index.IsRequired = _IsRequired["default"];
Index.IsValueValid = _IsValueValid["default"];
Index.Submit = _Submit["default"];
var _default = Index;
exports["default"] = _default;